//
//  ViewController.m
//  HydeCar
//
//  Created by hyde on 07/02/13.
//  Copyright (c) 2013 hyde. All rights reserved.
//

#import "ViewController.h"

@interface ViewController () {
	BTstackManager *btManager;
    uint16_t channel;
    BTDevice* curr_device;
    int mright;
    int mleft;
}

-(void) sendNewDirection;
@end

@implementation ViewController

static BOOL done = NO;
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    self->channel =CHANNEL_CONN;
    
#if HAS_BTSTACK
    NSLog(@"will active bt manager");
    self->btManager = [BTstackManager sharedInstance];
    self->btManager.delegate = self;
    
	BTstackError err = [btManager activate];
	if (err) NSLog(@"activate err 0x%02x!", err);
#endif
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)directionChanged:(id)sender {
    if( sender ) {
        [self performSelector:_cmd withObject:nil afterDelay:0];
        return;
    }
    self->mleft = self->mright = 0;
    for(UIButton *b in self->_buttons ){
        if( !b.touchInside ) continue;
        if( b.tag == 1 )
            self->mleft = 1;
        else if( b.tag == 2 )
            self->mleft = -1;
        else if( b.tag == 3 )
            self->mright = 1;
        else if( b.tag == 4 )
            self->mright = -1;
    }
    [self sendNewDirection];
}

-(void) sendNewDirection {
    uint8_t data[1] = {0x0};
    if( self->mleft == 1 )
        data[0] |= 0B00001100;
    else if( self->mleft == -1 )
        data[0] |= 0B11000000;
    if( self->mright == 1 )
        data[0] |= 0B00000011;
    else if( self->mright == -1 )
        data[0] |= 0B00110000;
    
    [self->btManager sendRFCOMMPacket:data ofSize:1 ForChannel:self->channel];
    
}

-(void) pingCar {
    uint8_t data[1] = {0x55};
    [self->btManager sendRFCOMMPacket:data ofSize:1 ForChannel:self->channel];
    [self performSelector:_cmd withObject:nil afterDelay:0.2];
}

-(void) btstackManager:(BTstackManager*)manager deviceInfo:(BTDevice*)device {
	NSLog(@"Device Info: addr %@ name %@ COD 0x%06x", [device addressString], [device name], [device classOfDevice] );
    if( device.classOfDevice == 0x1f00 && !done && [device.addressString isEqualToString:BT_ADDR] ){
        curr_device = device;
        done = YES;
        [manager stopDiscovery];
        NSLog(@"launching connexion");
        [manager createRFCOMMConnection:device.address onChannel:CHANNEL_CONN];
    }
}
-(void)btstackManager:(BTstackManager *)manager discoveryQueryRemoteName:(int)deviceIndex {
    BTDevice* device = [self->btManager deviceAtIndex:deviceIndex];
    NSLog(@"discovery: %@", device.nameOrAddress);
    NSLog(@"device type: %u", device.deviceType);
    NSLog(@"device type: %u", device.classOfDevice);
}

- (void)activatedBTstackManager:(BTstackManager *)manager {
    NSLog(@"activated, starting discovery");
    [manager startDiscovery];
}

-(void) btstackManager:(BTstackManager*)manager activationFailed:(BTstackError)error {
	NSLog(@"activationFailed error 0x%02x!", error);
};

- (NSString *)btstackManager:(BTstackManager *)manager pinForAddress:(bd_addr_t)addr {
    return PAIR_PIN_CODE;
}

//RFCOMM
-(void) btstackManager:(BTstackManager *)manager rfcommChannelOpened:(uint16_t)channel mtu:(uint16_t)mtu {
    NSLog(@"RFCOMM channel open succeeded. New RFCOMM Channel ID %u, max frame size %u", channel, mtu);
    self->channel = channel;
    [self.loader stopAnimating];
    self.connectedImg.hidden = NO;
    [self performSelector:@selector(pingCar) withObject:nil afterDelay:0.2];
}

- (void)btstackManager:(BTstackManager *)manager rfcommConnexionFailedWithStatus:(uint8_t)status {
    NSLog(@"RFCOMM channel open failed, status %u", status);
    [manager startDiscovery];
    [self.loader startAnimating];
    self.connectedImg.hidden = YES;
    done = NO;
}

- (void)btstackManager:(BTstackManager *)manager rfcommDataReceivedFromChannel:(uint16_t)channel withData:(uint8_t *)packet ofLen:(uint16_t)size {
    
}

-(BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation {
    return UIInterfaceOrientationIsLandscape(toInterfaceOrientation);
}

- (void)dealloc {
    [_loader release];
    [_connectedImg release];
    [super dealloc];
}
@end
